Google Kickstart Round-D D. Locked Doors(线段树+二分)

2024-04-15 22:58

本文主要是介绍Google Kickstart Round-D D. Locked Doors(线段树+二分),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题意:
n n n个点,相邻两点之间有一条边,每条边边权不同。
q q q次询问,每次询问给你一个起点 s s s,从这个点出发,每次往左右边权更小的点跑,求第 k k k个点是什么。
思路:
参考代码:https://doowzs.com/code/ks2020d-d/
想到了线段树,没想到二分。

  • 假设是求第 k k k个点,那结果可以看作是能包含 k k k个点的窗口。
  • 假设窗口左移,那么窗口左部分(起点 s s s左部分)的最大值一定会大于右部分最大值,否则移动的过程就会优先往左移。
  • 同理窗口右移,那么左部分最大值一定会小于有部分最大值。
  • 因此可以通过二分+线段树求区间最大值找到窗口的正确位置。
#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;
const int INF = 0x3f3f3f3f;
const int maxn = 4e5 + 7;
int d[maxn];
int n,q;
struct Tree {int l,r;int mx;
}t[maxn << 2];
void build(int i,int l,int r) {t[i].l = l;t[i].r = r;if(l == r) {t[i].mx = d[l];return;}int m = (l + r) >> 1;build(i * 2,l,m);build(i * 2 + 1,m + 1,r);t[i].mx = max(t[i * 2].mx,t[i * 2 + 1].mx);
}
int query(int i,int x,int y) {if(x <= t[i].l && t[i].r <= y) {return t[i].mx;}int m = (t[i].l + t[i].r) >> 1;int ans = 0;if(x <= m) ans = max(ans,query(i * 2,x,y));if(y > m) ans = max(ans,query(i * 2 + 1,x,y));return ans;
}
bool check(int s,int k,int left) {int L = s - left,R = s + (k - left);int mxL = query(1,L,s - 1);int mxR = query(1,s,R);return mxL < mxR;
}
int solve(int s,int k) {int left = 0,l = max(1,k - (n - s)),r = min(s - 1,k);while(l <= r) {int mid = (l + r) >> 1;if(check(s,k,mid)) {left = mid;l = mid + 1;} else {r = mid - 1;}}int ansL = s - left - 1;int ansR = s + (k - left);return d[ansL] < d[ansR] ? ansL : ansR + 1;
}
int main() {int T;scanf("%d",&T);int kase = 0;while(T--) {scanf("%d%d",&n,&q);for(int i = 1;i < n;i++) {scanf("%d",&d[i]);}d[0] = d[n] = INF;build(1,0,n);printf("Case #%d: ",++kase);for(int i = 1;i <= q;i++) {int s = 0,k = 0;scanf("%d %d",&s,&k);printf("%d ",k == 1 ? s : solve(s,k - 2));}printf("\n");}return 0;
}

这篇关于Google Kickstart Round-D D. Locked Doors(线段树+二分)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/907168

相关文章

hdu2241(二分+合并数组)

题意:判断是否存在a+b+c = x,a,b,c分别属于集合A,B,C 如果用暴力会超时,所以这里用到了数组合并,将b,c数组合并成d,d数组存的是b,c数组元素的和,然后对d数组进行二分就可以了 代码如下(附注释): #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<que

hdu2289(简单二分)

虽说是简单二分,但是我还是wa死了  题意:已知圆台的体积,求高度 首先要知道圆台体积怎么求:设上下底的半径分别为r1,r2,高为h,V = PI*(r1*r1+r1*r2+r2*r2)*h/3 然后以h进行二分 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#includ

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

poj 2976 分数规划二分贪心(部分对总体的贡献度) poj 3111

poj 2976: 题意: 在n场考试中,每场考试共有b题,答对的题目有a题。 允许去掉k场考试,求能达到的最高正确率是多少。 解析: 假设已知准确率为x,则每场考试对于准确率的贡献值为: a - b * x,将贡献值大的排序排在前面舍弃掉后k个。 然后二分x就行了。 代码: #include <iostream>#include <cstdio>#incl

poj 3104 二分答案

题意: n件湿度为num的衣服,每秒钟自己可以蒸发掉1个湿度。 然而如果使用了暖炉,每秒可以烧掉k个湿度,但不计算蒸发了。 现在问这么多的衣服,怎么烧事件最短。 解析: 二分答案咯。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <c

poj 3258 二分最小值最大

题意: 有一些石头排成一条线,第一个和最后一个不能去掉。 其余的共可以去掉m块,要使去掉后石头间距的最小值最大。 解析: 二分石头,最小值最大。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <c